JUCE: RecentlyOpenedFilesList Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
RecentlyOpenedFilesList Class Reference
juce_gui_extra » misc

Manages a set of files for use as a list of recently-opened documents. More...

`#include <juce_RecentlyOpenedFilesList.h>`

## Public Member Functions
| RecentlyOpenedFilesList ()
| Creates an empty list.
void | setMaxNumberOfItems (int newMaxNumber)
| Sets a limit for the number of files that will be stored in the list.
int | getMaxNumberOfItems () const noexcept
| Returns the number of items that this list will store.
int | getNumFiles () const
| Returns the number of files in the list.
File | getFile (int index) const
| Returns one of the files in the list.
const StringArray & | getAllFilenames () const noexcept
| Returns an array of all the absolute pathnames in the list.
void | clear ()
| Clears all the files from the list.
void | addFile (const File &file)
| Adds a file to the list.
void | removeFile (const File &file)
| Removes a file from the list.
void | removeNonExistentFiles ()
| Checks each of the files in the list, removing any that don't exist.
int | createPopupMenuItems (PopupMenu &menuToAddItemsTo, int baseItemId, bool showFullPaths, bool dontAddNonExistentFiles, const File **filesToAvoid=nullptr)
| Adds entries to a menu, representing each of the files in the list.
String | toString () const
| Returns a string that encapsulates all the files in the list.
void | restoreFromString (const String &stringifiedVersion)
| Restores the list from a previously stringified version of the list.

## Static Public Member Functions
static void | registerRecentFileNatively (const File &file)
| Tells the OS to add a file to the OS-managed list of recent documents for this app.
static void | forgetRecentFileNatively (const File &file)
| Tells the OS to remove a file from the OS-managed list of recent documents for this app.
static void | clearRecentFilesNatively ()
| Tells the OS to clear the OS-managed list of recent documents for this app.

## Detailed Description

Manages a set of files for use as a list of recently-opened documents.

This is a handy class for holding your list of recently-opened documents, with helpful methods for things like purging any non-existent files, automatically adding them to a menu, and making persistence easy.

See also
  File, FileBasedDocument

## Constructor & Destructor Documentation

## ◆ RecentlyOpenedFilesList()

RecentlyOpenedFilesList::RecentlyOpenedFilesList | ( |  | ) |

Creates an empty list.

## Member Function Documentation

## ◆ setMaxNumberOfItems()

void RecentlyOpenedFilesList::setMaxNumberOfItems | ( | int | newMaxNumber | ) |

Sets a limit for the number of files that will be stored in the list.

When addFile() is called, then if there is no more space in the list, the least-recently added file will be dropped.

See also
  getMaxNumberOfItems

## ◆ getMaxNumberOfItems()

int RecentlyOpenedFilesList::getMaxNumberOfItems | ( |  | ) | const
| noexcept

Returns the number of items that this list will store.

See also
  setMaxNumberOfItems

## ◆ getNumFiles()

int RecentlyOpenedFilesList::getNumFiles | ( |  | ) | const

Returns the number of files in the list.

The most recently added file is always at index 0.

## ◆ getFile()

File RecentlyOpenedFilesList::getFile | ( | int | index | ) | const

Returns one of the files in the list.

The most recently added file is always at index 0.

## ◆ getAllFilenames()

const StringArray & RecentlyOpenedFilesList::getAllFilenames | ( |  | ) | const
| noexcept

Returns an array of all the absolute pathnames in the list.

## ◆ clear()

void RecentlyOpenedFilesList::clear | ( |  | ) |

Clears all the files from the list.

## ◆ addFile()

void RecentlyOpenedFilesList::addFile | ( | const File & | file | ) |

Adds a file to the list.

The file will be added at index 0. If this file is already in the list, it will be moved up to index 0, but a file can only appear once in the list.

If the list already contains the maximum number of items that is permitted, the least-recently added file will be dropped from the end.

## ◆ removeFile()

void RecentlyOpenedFilesList::removeFile | ( | const File & | file | ) |

Removes a file from the list.

## ◆ removeNonExistentFiles()

void RecentlyOpenedFilesList::removeNonExistentFiles | ( |  | ) |

Checks each of the files in the list, removing any that don't exist.

You might want to call this after reloading a list of files, or before putting them on a menu.

## ◆ registerRecentFileNatively()

static void RecentlyOpenedFilesList::registerRecentFileNatively | ( | const File & | file | ) |
| static

Tells the OS to add a file to the OS-managed list of recent documents for this app.

Not all OSes maintain a list of recent files for an application, so this function will have no effect on some OSes. Currently it's just implemented for OSX.

## ◆ forgetRecentFileNatively()

static void RecentlyOpenedFilesList::forgetRecentFileNatively | ( | const File & | file | ) |
| static

Tells the OS to remove a file from the OS-managed list of recent documents for this app.

Not all OSes maintain a list of recent files for an application, so this function will have no effect on some OSes. Currently it's just implemented for OSX.

## ◆ clearRecentFilesNatively()

static void RecentlyOpenedFilesList::clearRecentFilesNatively | ( |  | ) |
| static

Tells the OS to clear the OS-managed list of recent documents for this app.

Not all OSes maintain a list of recent files for an application, so this function will have no effect on some OSes. Currently it's just implemented for OSX.

## ◆ createPopupMenuItems()

int RecentlyOpenedFilesList::createPopupMenuItems | ( | PopupMenu & | menuToAddItemsTo,
|  | int | baseItemId,
|  | bool | showFullPaths,
|  | bool | dontAddNonExistentFiles,
|  | const File ** | filesToAvoid = nullptr )

Adds entries to a menu, representing each of the files in the list.

This is handy for creating an "open recent file..." menu in your app. The menu items are numbered consecutively starting with the baseItemId value, and can either be added as complete pathnames, or just the last part of the filename.

If dontAddNonExistentFiles is true, then each file will be checked and only those that exist will be added.

If filesToAvoid is not a nullptr, then it is considered to be a zero-terminated array of pointers to file objects. Any files that appear in this list will not be added to the menu - the reason for this is that you might have a number of files already open, so might not want these to be shown in the menu.

It returns the number of items that were added.

## ◆ toString()

String RecentlyOpenedFilesList::toString | ( |  | ) | const

Returns a string that encapsulates all the files in the list.

The string that is returned can later be passed into restoreFromString() in order to recreate the list. This is handy for persisting your list, e.g. in a PropertiesFile object.

See also
  restoreFromString

## ◆ restoreFromString()

void RecentlyOpenedFilesList::restoreFromString | ( | const String & | stringifiedVersion | ) |

Restores the list from a previously stringified version of the list.

Pass in a stringified version created with toString() in order to persist/restore your list.

See also
  toString

The documentation for this class was generated from the following file:

- juce_RecentlyOpenedFilesList.h